@echo off
chcp 65001
set testfile="%ProgramFiles%\testfile.txt"
if exist %testfile% del /f /q %textfile% >nul
echo test > %testfile%
if not exist %testfile% goto dperror

del /f /q %testfile% >nul
set destdrive=W
set efidrive=s
set answer=N
set dpscript="%~dp0dispartcommands.txt"

:top
cls
echo.
echo  This program will clone a volume. It can also erase and create a bootable disk for cloning to.
echo.
echo  Select the desired option below
echo.
echo   1 = Create a GPT bootable disk for UEFI and clone the desired partition to it.
echo  This option is good for copying working, not failing disks or copying an MBR disk into a GPT one.
echo  The target disk will be erased, initiated as GPT and partitioned for a UEFI system.
echo  After the successful volume copy, the target disk is made bootable.
echo.
echo   2 = Create an MBR bootable disk for BIOS and clone the desired partition to it.
echo  This option is good for copying working, not failing disks or copying a GPT disk into an MBR one.
echo  The target disk will be erased, initiated as MBR and partitioned for a BIOS system.
echo  After the successful volume copy, the target disk is made bootable.
echo.
echo   3 = Just clone the desired partition. Do not erase the target disk nor update boot information.
echo  This option is great for copying failing disks. You can prepare the target disk yourself as follows:
echo  Install the same Windows major version in the target disk before running this batch.
echo  You do not need to complete the setup, install just up to the first reboot (usually less than 5 minutes).
echo.
if exist %dpscript% del /f /q %dpscript% > nul
set mode=0
set /p mode=Enter the desired option number (1, 2 or 3): 
if %mode% == 1 (goto setsource) else if %mode% == 2 (goto setsource) else if %mode% == 3 (goto setsource) else (goto badchoice)

:setsource 
cls
echo.
echo  Please indicate just the drive letter (without the colon), of the volume to copy.
echo.
set SourceWin=null
set /p SourceWin=Enter the source drive letter: 

if /i %SourceWin% == c (goto cselected)
if %mode% == 1 if not exist %SourceWin%:\Windows goto badchoice
if %mode% == 2 if not exist %SourceWin%:\Windows goto badchoice
if %mode% == 3 if not exist %SourceWin%:\ goto badchoice

if %mode% == 1 (goto gptpart) else if %mode% == 2 (goto mbrpart) else if %mode% == 3 (goto copyonly) else (goto badchoice)

:gptpart
cls
echo.
echo  Look at the disk list below and indicate the desired target disk's number
echo  Note that the disk you indicate will be fully erased and converted to GPT later
echo  If you do not see the disk list, close this window and notify the author of this script
echo.
echo list disk > %dpscript%
echo. >> %dpscript%
diskpart.exe /s %dpscript%
echo.

set TargetDisk=null
set /p TargetDisk=Enter the target disk number:
cls
echo.
echo  You chose to erase the disk %TargetDisk%. Partition info on the selected disk is shown below
echo.
echo select disk %TargetDisk% > %dpscript%
echo list partition >> %dpscript%
echo. >> %dpscript%
diskpart.exe /s %dpscript%
echo.
set answer=N
set /p answer=Press Y and then Enter to to erase and partition the selected disk (Y or N): 
if /i not %answer% == y goto badchoice
cls

echo.
echo  Erasing and partitioning the disk %TargetDisk% ...
echo.
echo select disk %TargetDisk% > %dpscript%
echo clean >> %dpscript%
echo convert GPT >> %dpscript%
echo. >> %dpscript%
diskpart.exe /s %dpscript%

cls
if exist %destdrive%:\ set destdrive=X
if exist %destdrive%:\ set destdrive=Y
if exist %destdrive%:\ set destdrive=Z

if exist %efidrive%:\ set efidrive=T
if exist %efidrive%:\ set efidrive=U
if exist %efidrive%:\ set efidrive=V

echo select disk %TargetDisk% > %dpscript%
echo create partition efi size=100 >> %dpscript%
echo format quick fs=fat32 label="System" >> %dpscript%
echo assign letter=%efidrive% >> %dpscript%

echo create partition primary >> %dpscript%
echo format quick fs=ntfs label="Windows" >> %dpscript%
echo assign letter=%destdrive% >> %dpscript%
echo. >> %dpscript%

diskpart.exe /s %dpscript%
goto copy

:mbrpart
cls
echo.
echo  Look at the disk list below and indicate the desired target disk's number
echo  Note that the disk you indicate will be fully erased and converted to MBR later
echo  If you do not see the disk list, close this window and notify the author of this script
echo.
echo list disk > %dpscript%
echo. >> %dpscript%
diskpart.exe /s %dpscript%
echo.

set /p TargetDisk=Enter the target disk number: 
cls
echo.
echo  You chose to erase the disk %TargetDisk%. Partition info on the selected disk is shown below
echo.
echo select disk %TargetDisk% > %dpscript%
echo list partition >> %dpscript%
echo. >> %dpscript%
diskpart.exe /s %dpscript%
echo.
set answer=N
set /p answer=Press Y and then Enter to to erase and partition the selected disk (Y or N): 
if /i not %answer% == y goto badchoice
cls

echo.
echo  Erasing and partitioning the disk %TargetDisk% ...
echo.
echo select disk %TargetDisk% > %dpscript%
echo clean >> %dpscript%
echo convert MBR >> %dpscript%
echo. >> %dpscript%
diskpart.exe /s %dpscript%

cls
if exist %destdrive%:\ set destdrive=X
if exist %destdrive%:\ set destdrive=Y
if exist %destdrive%:\ set destdrive=Z

echo select disk %TargetDisk% > %dpscript%
echo create partition primary >> %dpscript%
echo format quick fs=ntfs label="Windows" >> %dpscript%
echo assign letter=%destdrive% >> %dpscript%
echo active >> %dpscript%
echo. >> %dpscript%21:01 16/08/2022
diskpart.exe /s %dpscript%
goto copy

:copyonly
cls
echo.
set destdrive=""
set /p destdrive=Enter the destination drive letter (just the letter, not the colon): 
if /i %destdrive% == c (goto cselected) 
goto copy

:copy
if exist %dpscript% del /f /q %dpscript% > nul
if not exist %destdrive%:\ goto failed
cls
echo.
set answer=N
set /p answer=Press Y and then Enter to to copy all data from %SourceWin%:\ to %destdrive%:\ (Y\N): 
if not %answer% == Y if not %answer% == y goto  badchoice
cls
echo.
echo  This program is now copying the files. Only copy errors are shown below.
echo  For progress info, compare the used space between %SourceWin%:\ and %destdrive%:\

echo.
robocopy.exe %SourceWin%:\ %destdrive%:\ /E /COPYALL /B /R:0 /XJD /SL /ETA /UNICODE /NFL /NDL /XF hiberfil.sys pagefile.sys swapfile.sys /XD "System Volume Information"
start wmplayer "%windir%\media\Alarm01.wav"
set fail=1
FOR /f "tokens=*" %%i IN ('dir %SourceWin%:\ /b') DO (if exist %destdrive%:\%%i set fail=0)
if %mode% == 3 if %fail% == 0 (goto success) else (goto failed)

if not exist %destdrive%:\windows\system32\shell32.dll if %fail% == 0 (goto success) else (goto failed)

echo  Now updating boot information...
if %mode% == 1 (bcdboot.exe %destdrive%:\windows /s %efidrive%: /f UEFI) else if %mode% == 2 (bcdboot.exe %destdrive%:\windows /s %destdrive%: /f BIOS)
if %fail% == 1 (goto failed) else if errorlevel 1 (goto failed) else (goto success)
exit

:badchoice
echo.
echo  Oops, you seem to have entered a wrong choice! Press a key to try again
echo.
pause >nul
goto top

:dperror
echo.
echo  Please run this batch as administrator!
echo.
pause >nul
exit

:cselected
echo.
echo  Oops, you selected the C:\ drive as the source or target. This script can not copy from or to this volume
echo  Press any key to try again
echo.
pause >nul
goto top

:failed
echo.
echo  Oops, something went wrong. not all tasks have been successfully completed
echo  Press any key to try again
echo.
pause >nul
goto top

:success
cls
echo.
echo  The operation completed successfully
echo  Press any key to make a new copy, otherwise close this program
echo.
pause >nul
goto top

